* Create the DBFListener object and use it to run the report.

loListener = newobject('DBFListener', 'DBFListener.PRG')
report form Customers object loListener

* Show the report in our custom previewer.

loForm = newobject('SFPreviewForm', 'SFPreview.vcx')
with loForm
	.cOutputAlias = loListener.cOutputAlias
	.Caption      = 'Customer Report'
	.oListener    = loListener
	.FirstPage()
endwith

* Bind to the object click events so we can handle them.

loHandler = createobject('ClickHandler')
bindevent(loForm, 'ObjectClicked',      loHandler, 'OnClick')
bindevent(loForm, 'ObjectDblClicked',   loHandler, 'OnDblClick')
bindevent(loForm, 'ObjectRightClicked', loHandler, 'OnRightClick')

* Display the debug output window and the preview form.

activate window 'debug output'
loForm.Show(1)

* A class to handle object clicks.

define class ClickHandler as Custom
	procedure OnClick(toObject)
		do case
			case inlist(toObject.ObjType, 5, 8)
				debugout 'You clicked ' + trim(toObject.Contents)
			case toObject.ObjType = 7
				debugout 'You clicked a rectangle'
			case toObject.ObjType = 6
				debugout 'You clicked a line'
			case toObject.ObjType = 17
				debugout 'You clicked an image'
		endcase
	endproc

	procedure OnDblClick(toObject)
		do case
			case inlist(toObject.ObjType, 5, 8)
				debugout 'You double-clicked ' + trim(toObject.Contents)
			case toObject.ObjType = 7
				debugout 'You double-clicked a rectangle'
			case toObject.ObjType = 6
				debugout 'You double-clicked a line'
			case toObject.ObjType = 17
				debugout 'You double-clicked an image'
		endcase
	endproc

	procedure OnRightClick(toObject)
		do case
			case inlist(toObject.ObjType, 5, 8)
				debugout 'You right-clicked ' + trim(toObject.Contents)
			case toObject.ObjType = 7
				debugout 'You right-clicked a rectangle'
			case toObject.ObjType = 6
				debugout 'You right-clicked a line'
			case toObject.ObjType = 17
				debugout 'You right-clicked an image'
		endcase
	endproc
enddefine
